import { faBrush, faChartLine, faCrosshairs, faDrawPolygon, faEdit, faEraser, faGripLines, faHandPaper, faMask, faMousePointer, faRedo, faSearchMinus, faSearchPlus, faTag, faUndo, faVectorSquare } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import AccessibilityNewIcon from "@mui/icons-material/AccessibilityNew";
import FullscreenIcon from "@mui/icons-material/Fullscreen";
import React from "react";
var faStyle = {
  marginTop: 4,
  width: 16,
  height: 16,
  marginBottom: 4
};
export var iconDictionary = {
  select: function select() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faMousePointer
    });
  },
  pan: function pan() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faHandPaper
    });
  },
  zoom: function zoom() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faSearchPlus
    });
  },
  zoom_tool_minus: function zoom_tool_minus() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faSearchMinus
    });
  },
  "show-tags": function showTags() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faTag
    });
  },
  "create-point": function createPoint() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faCrosshairs
    });
  },
  "create-box": function createBox() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faVectorSquare
    });
  },
  "create-a-brush": function createABrush() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faBrush
    });
  },
  undo_anntation: function undo_anntation() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      id: "undo",
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faUndo
    });
  },
  redo_anntation: function redo_anntation() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      id: "redo",
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faRedo
    });
  },
  "create-polygon": function createPolygon() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faDrawPolygon
    });
  },
  "create-expanding-line": function createExpandingLine() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faGripLines
    });
  },
  "create-line": function createLine() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faChartLine
    });
  },
  "show-mask": function showMask() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faMask
    });
  },
  "modify-allowed-area": function modifyAllowedArea() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faEdit
    });
  },
  eraser: function eraser() {
    return /*#__PURE__*/React.createElement(FontAwesomeIcon, {
      style: faStyle,
      size: "xs",
      fixedWidth: true,
      icon: faEraser
    });
  },
  "create-keypoints": AccessibilityNewIcon,
  window: FullscreenIcon
};
export default iconDictionary;